
// $Id: converter_iface.js,v 1.4 2009/04/05 01:03:12 bogdan Exp $

if (MCE!=undefined && MCE.applicationName=='Converter') {

MCE.iface={
	showLocation:function(loc)
	{
		window.setTimeout(function() {
			MCE.iface.browse(loc);
		}, 100);
	},

	browse:function(loc)
	{
//		window.open(loc,'_blank',null);
		var newTab = gBrowser.addTab(loc);
		gBrowser.selectedTab = newTab;
	},

	doWelcome:function()
	{
	  var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                      getService(Components.interfaces.nsIPrefService);
	  var ver=MCE.applicationVersion;
	  var decision=false;
	  prefs = prefs.getBranch("extensions.converter.");
	  // IMPORTANT! The order of the tests below is significant!
	  if (
	    (prefs.getPrefType('current_version')==prefs.PREF_INVALID) ||
	    (prefs.getCharPref('current_version')=='')
	  ) {
	    prefs.setCharPref('current_version',ver);
	    decision='install';
	  }
	  if (
	    (prefs.getPrefType('first_version')==prefs.PREF_INVALID) ||
	    (prefs.getCharPref('first_version')=='')
	  ) {
	    prefs.setCharPref('first_version',prefs.getCharPref('current_version'));
	  }
	  if (prefs.getCharPref('current_version')!=ver) {
	    prefs.setCharPref('current_version',ver);
	    decision='upgrade';
	  }
	  if (!decision) {
	    return false;
	  }
	  var fver=prefs.getCharPref('first_version');
	  if (decision=='install') {
	    if (
	      confirm(
	        "Congratulations!\n"+
	        "-------------------------------------\n"+
	        "\n"+
	        "You have successfully installed the Converter extension!\n"+
	        "\n"+
	        "Would you like to learn how to use it?"
	      )
	    ) {
	      this.showLocation("http://converter.mozdev.org/welcome.html?ver="+ver);
	    }
	  }
	  if (decision=='upgrade') {
	    if (
	      confirm(
	        "Congratulations!\n"+
	        "-------------------------------------\n"+
	        "\n"+
	        "You have successfully upgraded the Converter extension!\n"+
	        "\n"+
	        "Would you like to find out what's new?"
	      )
	    ) {
	      this.showLocation("http://converter.mozdev.org/whatsnew.html?ver="+ver+"&fver="+fver);
	    }
	  }
	  return true;
	},

	setNewPage:function(objEvent)
	{
	  var cDoc=objEvent.originalTarget;
	  var cBodyT=cDoc.getElementsByTagName("body");
	  var cBody=(cBodyT.length > 0) ? cBodyT[0] : false;
	  if (cBody) {
	    cBody.setAttribute("converter_extension_converted",false);
	  }
	},

	setOldPage:function(cDoc)
	{
	  var cBodyT=cDoc.getElementsByTagName("body");
	  var cBody=(cBodyT.length > 0) ? cBodyT[0] : false;
	  if (cBody) {
	    cBody.setAttribute("converter_extension_converted",true);
	  }
	},

	isNewPage:function(cDoc)
	{
	  var cBodyT=cDoc.getElementsByTagName("body");
	  var cBody=(cBodyT.length > 0) ? cBodyT[0] : false;
	  if (cBody) {
	    var tmp=(cBody.getAttribute("converter_extension_converted")=="true")?true:false;
	    return !tmp;
	  }
	  // This should be meaningless, as far as I can tell
	  return true;
	},

	initControls:function()
	{
	  var statIcon=document.getElementById('converter_status');
	  if (statIcon) {
	    statIcon.hidden = !MCE.pref_util.getPref('pref_fullpage_icon');
	  }
	},

	init:function()
	{
	  // Welcome first ------------------------------------------------------------
	  MCE.iface.doWelcome();

	  window.addEventListener('load',MCE.iface.setNewPage,true);

	  // Now the proper stuff -----------------------------------------------------
	  var tmpElement=document.getElementById("contentAreaContextMenu");
	  if (tmpElement)
	    tmpElement.addEventListener("popupshowing",MCE.iface.onPopup,false);
	  MCE.iface.initControls();
	},

	/**
	* This function is executed when the popup menu pops up. It just triggers
	* MCE.core.doConversion() and, depending on the result, shows the result
	* in the popup menu.
	*/
	onPopup:function()
	{
	  var item = document.getElementById("context_converterselect");
	  if (!gContextMenu.isTextSelected){
	    if (!MCE.pref_util.getPref('pref_fullpage_menu')) {
	      item.hidden=true;
	      return true;
	    }
	    if (!MCE.iface.isNewPage(content.document)) {
	      item.hidden = true;
	      return true;
	    }
	    item.hidden = false;
	    item.setAttribute("label", 'Convert the entire page');
	    return true;
	  }
	  if (!MCE.pref_util.getPref('pref_selection_menu')) {
	    item.hidden=true;
	    return true;
	  }
	  if (gContextMenu.searchSelected) {
	    // FF 1.x
	    var sel=gContextMenu.searchSelected();
	  } else {
	    // FF 2.x+
	    var sel=getBrowserSelection();
	  }
	  var cr=MCE.core.doConversion(sel,false);
	  if (!cr || cr.inhibit) {
	    item.hidden=true;
	    return true;
	  }

	  item.hidden = false;
	  var label = cr.inValue + " " + cr.inUnit + " = " + cr.outCustom;
	  item.setAttribute("label", label);
	  return true;
	},

	/**
	* This function is called when the user clicks on the converter entry
	* in the popup.
	*/
	onConvert:function()
	{
	  if (!gContextMenu.isTextSelected)
	    MCE.core.convertPage();
	  return true;
	},

	statusClicked:function(evt)
	{
	  /*
	  // Unfortunately icon switching doesn't work well with tabs, to my knowledge,
	  // so we'll have to keep a single icon throughout. See linkification.
	  var cvStatus = document.getElementById("converter-status-hbox");
	  cvStatus.src = 'chrome://converter/skin/cv_stat_on.png';
	  alert("Clicked!");
	  */
	  if (evt.button != 0)
	  {
	    return true;
	  }
	  this.fullPageFromStatus();
	},

	fullPageFromStatus:function()
	{
	  if (this.isNewPage(content.document)) {
	    MCE.core.convertPage();
	  }
	},

	customConversionPopup:function()
	{
	  // width=430,height=385,resizable
	  window.openDialog("chrome://converter/content/custom_conversion.xul",
	    "Converter_custom", "chrome"
	  );
	},

	openPrefsWindow:function()
	{
	  window.openDialog("chrome://converter/content/converterPrefDialog.xul",
	    "Converter_preferences", "chrome"
	  );
	}
}

window.addEventListener("load",MCE.iface.init,false);

}
